This perl script is intended to add the contents of the classification
and references together with the signatures to the database.
If this values are already part of the database then the INSERTs
of alerts should be faster (there is no need to add the signature
together with the alert).

To use rules.pl to insert/update the signatures into the database you
have to adjust the first lines in the perl script.

$ClassFile should point to the location of the classification.config
file, $ReferenceFile should point to the location of the reference.config
file and finally in the DBI->connect line you have to insert the
data to access the database.

Actually a postgresql database (DBI::Pg) is used but it should be
no problem to replace it with a MySQL database.

The first entry contains the database name, default is "snort":

"DBI:Pg:dbname=snort"

The second entry is the name of the database user, here it is 
snort too:

 "snort"

The third entry is the password, actually it is empty:

 ""

The last thing you can adjust is the variable $PrioRange. By
default it is set to zero which means to use the priority given
by the signature.

One problem with the priority is that it is normally inserted
once, if you later on change this priority then the database
will still show the old priority. This behaviour is inherited
from the original spo_database.c plugin of snort. (FLoP will
still check for the priority since version 1.3.0)

However if you enable DBTrust then a new signature will be 
added to the database with the new priority. But then you 
will lose the references.

Here you can now use $PrioRange, if this is set for example
to 5 then all signatures are inserted with priorities from
1 to 5. 

I think it should be possible to use the same rule with 
different priorities depending on the location of the sensor.
For example a web rule in front of a mail server may have a
lower priority than in front of a web server...

If you have adjusted all the parameters then you can invoke
the perl script with the rules file, e.g.:

./rules.pl bad-traffic.rules

or simply use all rules files:

./rules.pl *.rules


One comment on the priorities and classification.config:

Normally the priority can be given with each signature
with the keyword "priority". But with the default rules
as part of snort this keyword is never used.

Instead the priority is taken from the classification.config
file. This should be the default priority and most users of
snort should adjust the priorities by their needs.

If neither a priority nor a classification nor is given with
the rule then a default priority of 2 is used.

One comment on the reference.config file:

This file maps between the system like cve and the URL
like http://cve.mitre.org/cgi-bin/cvename.cgi?name=

But only the first part, the system, is part of the
database. The URL must be estimated by the viewing
program like ACID or whatever you like to use...

(For example: ACID maps these entries in acid_conf.php.) 

