#!/usr/bin/perl

BEGIN { push (@INC,'/var/apache/cgi-bin') ;};

use CGI;
use DBI;          # database module
use dbh;
#use Date::Format; # to convert the time in seconds to a string
use strict;


my $packet_id;
my $q = new CGI;
my $sid = $q->param('sid');
my $cid = $q->param('cid');
my $connected=0;
my $dbh;

print $q->header("text/html");
print $q->start_html("Snort DB");

my $dbh = dbh::OpenDB();

if (!($sid) || !($cid)) 
{
    Exit($dbh,"Error: sid and cid must be valid.");
}

if ( !($sid =~ /^(\d+)$/) || ! ($cid =~ /^(\d+)$/) )
{
    Exit($dbh,"Error: sid and cid must be numerical.");
}

my $sql="SELECT hostname,encoding FROM sensor WHERE sid = $sid";
my $sth=$dbh->prepare($sql);
$sth->execute();
(my $sensorname, my $encoding) = $sth->fetchrow_array();
$sth->finish();
if (!$sensorname) { Exit($dbh,"No such sensor");}
$sql="SELECT signature,timestamp FROM event WHERE cid = $cid and sid = $sid ";
$sth=$dbh->prepare($sql);
$sth->execute();
(my $signature, my $timestamp) = $sth->fetchrow_array();
$sth->finish();


if (!($signature)) { Exit($dbh,"No such event");} 

$sql="SELECT sig_name, sig_priority, sig_rev, sig_class_id, sig_sid FROM signature WHERE sig_id = $signature";
$sth=$dbh->prepare($sql);
$sth->execute();
(my $message, my $priority, my $revision, my $class_id, my $sig_sid) = 
    $sth->fetchrow_array();
$sth->finish();

$sql="SELECT * FROM iphdr WHERE ( cid = $cid and sid = $sid ) ";
$sth=$dbh->prepare($sql);
$sth->execute();

my @fields = $sth->fetchrow_array();
$sth->finish();
#  print join ("\t",@fields);
print $q->h1({-align=>"center"},$message);

$packet_id=$fields[0] . "-" . $fields[1];
while (length($timestamp) < 26) { $timestamp .= "0"; }

print $q->table( { -border=>1, -width=>"100%" },
		 $q->Tr( [ $q->th( {-bgcolor=>"#cccccc"},
			   [ "Packet-ID", "Sensor", "Time", "Priority", 
			     "Revision", "Signature-ID"  ] ), 
			   $q->td( {-align => "center" }, 
				   [ $packet_id, $q->a({-href=>"/cgi-bin/list.pl?off=0&lim=20&sid=$sid"},$sensorname), $timestamp, 
				     $priority, $revision,$sig_sid ] )
			   ] ) 
		 );

my $class_desc;
$sql="SELECT sig_class_name FROM sig_class WHERE sig_class_id = $class_id";
$sth=$dbh->prepare($sql);
$sth->execute();

my $class_desc = $sth->fetchrow_array();
$sth->finish();

print $q->table( { -border=>1, -width=>"100%" },
		 $q->Tr( [ $q->th( {-bgcolor=>"#cccccc"},
			   [ "Class-ID", "Class-Description"
			     ] ), 
			   $q->td( {-align => "center" }, 
				   [ $class_id, $class_desc
				    ] 
				   )
			   ] 
			 ) 
		 );

my @SRC;
my @DST;
@SRC=convertIP($fields[2]); 
@DST=convertIP($fields[3]); 
my $src='';
my $dst='';
for (my $i=0; $i<4; $i++) 
{ 
    $src .= hex($SRC[$i]); 
    $dst .= hex($DST[$i]); 
    if ($i<3) 
    { 
	$src .= ".";
	$dst .= ".";
	}
}
print $q->h1({-align=>"center"},"IP");
print $q->table( { -border=>1, -width=>"100%" },
		 $q->Tr( [ $q->th( {-bgcolor=>"#cccccc"},
			   [ "Version", "HLen", "TOS", "length", 
			     "IP-ID", "Fragment", "Offset", "TTL" 
			     ] ), 
			   $q->td( {-align => "center" }, 
				   [$fields[4], $fields[5], $fields[6], 
				    $fields[7], $fields[8], $fields[9],
				    $fields[10], $fields[11] 
				    ] 
				   )
			   ] 
			 ) 
		 );

my $prot=$fields[12];
my $ref;
if ($prot == 1 || $prot == 6 || $prot == 17)
{
   $ref=$q->a({-href=>"/cgi-bin/list.pl?off=0&lim=20&proto=$prot"},$prot); 
}
else 
{
   $ref=$prot
}
print $q->table( { -border=>1, -width=>"100%" },
		 $q->Tr( [ $q->th( {-bgcolor=>"#cccccc"},  
		       	     [ "Sourceaddress" , "Destinationaddress",
			       "Protocol", "Checksum"
			       ]
				   ),
			     $q->td( {-align => "center" }, 
				     [$q->a({-href=>"/cgi-bin/ip.pl?src=$fields[2]"},$src), 
				     $q->a({-href=>"/cgi-bin/ip.pl?dst=$fields[3]"},$dst), 
				     $ref, $fields[13] ])
			   ]
			 )
		 );

if ($prot==17) { getUDP($dbh,$sid,$cid); }
elsif ($prot==6) { getTCP($dbh,$sid,$cid); }
elsif ($prot==1) { getICMP($dbh,$sid,$cid); }
else { print $q->p("Protocol not supported"); }

getPayload($dbh,$sid,$cid);

print $q->end_html;
$dbh->disconnect;

sub convertIP
{
    my $IP=shift;
    $IP=sprintf("%x",$IP);
    if (length($IP) < 8) { $IP = '0' . $IP; }
    return unpack("a2 a2 a2 a2",$IP);
}

sub getUDP
{
    my ($dbh,$sid,$cid)=@_;
    my $sql="SELECT * FROM udphdr WHERE ( cid = $cid and sid = $sid ) ";
    my $sth=$dbh->prepare($sql);
    $sth->execute();
    my @fields = $sth->fetchrow_array();
    $sth->finish();
    print $q->h1({-align=>"center"},"UDP");
    print $q->table( { -border=>1, -width=>"100%" },
	     $q->Tr( [ $q->th( {-bgcolor=>"#cccccc"},  
		     [ "Sourceport" , "Destinationport",
		       "UDP length", "UDP Checksum"
                     ]
	          ),
     $q->td( {-align => "center" },
	     [ $q->a({-href=>"http://www.portsdb.org/bin/portsdb.cgi?portnumber=$fields[2]&protocol=UDP"}, $fields[2]), 
	       $q->a({-href=>"http://www.portsdb.org/bin/portsdb.cgi?portnumber=$fields[3]&protocol=UDP"}, $fields[3]), 
	       $fields[4], $fields[5] ])
	     ]
	   )
		   );

}

sub getTCP
{
    my ($dbh,$sid,$cid)=@_;
    my $sql="SELECT * FROM tcphdr WHERE ( cid = $cid and sid = $sid ) ";
    my $sth=$dbh->prepare($sql);
    $sth->execute();
    my @fields = $sth->fetchrow_array();
    $sth->finish();
    print $q->h1({-align=>"center"},"TCP");
    my $flags=$fields[8];
    my $fl='';
    if ($flags & 0x01) {$fl .= "F"};
    if ($flags & 0x02) {$fl .= "S"};
    if ($flags & 0x04) {$fl .= "R"};
    if ($flags & 0x08) {$fl .= "P"};
    if ($flags & 0x10) {$fl .= "A"};
    if ($flags & 0x20) {$fl .= "U"};
    if ($flags & 0x40) {$fl .= "2"};
    if ($flags & 0x80) {$fl .= "1"};
    
    print $q->table( { -border=>1, -width=>"100%" },
	   $q->Tr( [ $q->th( {-bgcolor=>"#cccccc"},  
		     [ "Sourceport" , "Destinationport",
		       "Windowsize", "Sequential",
		       "Acknowledge"
                     ]
	          ),
     $q->td( {-align => "center" },
	     [ $q->a({-href=>"http://www.portsdb.org/bin/portsdb.cgi?portnumber=$fields[2]&protocol=TCP"}, $fields[2]), 
	       $q->a({-href=>"http://www.portsdb.org/bin/portsdb.cgi?portnumber=$fields[3]&protocol=TCP"}, $fields[3]), 
	       $fields[9], $fields[4], $fields[5] ])
	     ]
	   )
		   );

    print $q->table( { -border=>1, -width=>"100%" },
		   $q->Tr( [ $q->th( {-bgcolor=>"#cccccc"},  
				     [ "Flags","Checksum" , "Urgentpointer",
				       "TCP Header", "Reserved"
				       ]
				     ),
			     $q->td( {-align => "center" }, [$fl,$fields[10], 
				      $fields[11], $fields[6], $fields[7] ])
			     ]
			   )
		   );
	  }


sub getICMP
{
    my ($dbh,$sid,$cid)=@_;
    my $sql="SELECT * FROM icmphdr WHERE ( cid = $cid and sid = $sid ) ";
    my $sth=$dbh->prepare($sql);
    $sth->execute();
    my @fields = $sth->fetchrow_array();
    $sth->finish();
    print $q->h1({-align=>"center"},"ICMP");
    print $q->table( { -border=>1, -width=>"100%" },
	     $q->Tr( [ $q->th( {-bgcolor=>"#cccccc"},  
		     [ "Type" , "Code", "ICMP Checksum", "ICMP ID", 
		       "ICMP Sequence" ] ),
     $q->td( {-align => "center" },
	     [ 
	       $fields[2], $fields[3], $fields[4], $fields[5], $fields[6] ])
	     ]
	   )
		   );
}

sub getPayload
{
    my ($dbh,$sid,$cid)=@_;
    my $mod=30;
    my $i;
    my $char;
    my $ascii;
    my $line;
    my @col;

    my $sql="SELECT data_payload FROM data WHERE cid = $cid and sid = $sid ";
    my $sth=$dbh->prepare($sql);
    $sth->execute();
    my $payload = $sth->fetchrow_array();
    $sth->finish();
    if (length($payload)==0) { return; }
    print $q->h1({-align=>"center"}, "PAYLOAD");
    $i=0;
    my $len=length($payload);
    $char='';
    $ascii='';
    $line='';
    while ($i < $len)
    {
	my $sign= substr($payload,$i,2);
	$char=hex($sign);
	if ( $char <32 || $char >126 ) { $ascii = $ascii . '.'}
	else { $ascii = $ascii . chr($char); }
	$line .= $sign . " ";
	$i+=2;
	if ($i%$mod==0) 
	{ 
	    push @col, $q->td([ $q->tt($line), $q->tt($ascii) ]);
	    $line='';
	    $ascii='';
	}
    }
    if ($i%$mod !=0) 
    {
	push @col, $q->td([$q->tt($line),$q->tt($ascii)]);
    }
    print $q->table( { -border=>1, -width=>"100%" },   
		     $q->Tr( [ $q->th( {-bgcolor=>"#cccccc"},  
				       [ "Binary" , "Ascii" ]
				       ),
                             @col,
                             ]
                           )
                   );
}

sub Exit
{
    (my $dbh, my $message) = @_;
    print $q->p("$message");
    $dbh->disconnect();
    print $q->end_html;
    exit;
}
