#!/usr/bin/perl

BEGIN { push (@INC,'/var/apache/cgi-bin') ;};

use CGI;
use DBI;          # database module
use dbh;
#use Date::Format; # to convert the time in seconds to a string
use strict;


my $packet_id;
my $q = new CGI;
my $sid;
my $selsid=0+$q->param("sid");
my $cid;
my $hostname;
my @cols;
my $sql;
my $sth;
my $lim=0+$q->param("lim");
my $off=0+$q->param("off");
my $proto=0+$q->param("proto");
$lim=20 if $lim==0;

print $q->header("text/html");
print $q->start_html("Snort DB");

my $dbh = dbh::OpenDB();

my $prothdr;
my $where="";

if ($proto>0)
{
  $where=", iphdr WHERE iphdr.ip_proto= $proto AND event.cid=iphdr.cid AND event.sid = iphdr.sid ";
  if ($selsid>0) 
  {
   $where .= "AND event.sid = $selsid";
  }
}
elsif ($proto<0)
{
    $where=", iphdr WHERE iphdr.ip_proto <> 6 AND iphdr.ip_proto <> 1 AND iphdr.ip_proto <> 17 AND event.cid=iphdr.cid AND event.sid = iphdr.sid ";
  if ($selsid>0) 
  {
   $where .= "AND event.sid = $selsid";
  }
}
elsif ($selsid>0)
{
    $where=" WHERE sid=$selsid";
}
$sql="SELECT event.sid,event.cid,event.timestamp,event.signature FROM event $where ORDER BY timestamp DESC LIMIT $lim OFFSET $off";
#print $q->a($sql);
$sth=$dbh->prepare($sql);
$sth->execute();

my $time;
my $count=$off;
my @SRC;
my @DST;
my $src_ip;
my $dst_ip;
my $packet='';
my $signature;
my $sig;
@cols=();

while (($sid,$cid,$time,$signature)=$sth->fetchrow_array())
{
    while (length($time) < 26) { $time .= "0"; }
    $count++;
    my $src=getWResult($dbh,"ip_src","iphdr","(cid=$cid AND sid=$sid)");
    my $dst=getWResult($dbh,"ip_dst","iphdr","(cid=$cid AND sid=$sid)");
    $sig=getWResult($dbh,"sig_name","signature","sig_id=$signature");
    @SRC=convertIP($src); 
    @DST=convertIP($dst); 
    $src_ip='';
    $dst_ip='';
    for (my $i=0; $i<4; $i++) 
    { 
	$src_ip .= hex($SRC[$i]); 
	$dst_ip .= hex($DST[$i]); 
	if ($i<3) 
	{ 
	    $src_ip .= ".";
	    $dst_ip .= ".";
	}
    }
    $packet = $sid . "-" . $cid;
    push @cols, $q->td( {-align => "center" },
			[ $count, $q->a({-href=>"/cgi-bin/db-cgi.pl?sid=$sid&cid=$cid"}, $packet), $time, 
$q->a({-href=>"/cgi-bin/ip.pl?src=$src"}, $src_ip), 
$q->a({-href=>"/cgi-bin/ip.pl?dst=$dst"}, $dst_ip), 
$q->a({-href=>"/cgi-bin/signature.pl?signature=$signature"},$sig) ]);
}
$sth->finish();

print $q->h1("Results");
print $q->table( { -border=>1, -width=>"100%" },   
		 $q->Tr( [ $q->th( {-bgcolor=>"#cccccc"},  
				   [ "#" , "Packet-ID", "Time", "Source","Destination", "Signature"  ] ), 
			   @cols,  ] )
		 );

$dbh->disconnect();
my $next=$count;
my $back=$off-$lim;

my $link="lim=$lim";
$link .= "&proto=$proto" if $proto != 0;
$link .= "&sid=$sid" if $sid;

my $line='';
if ($back >= 0 )
{
    $line .= $q->a({ -href=>"/cgi-bin/list.pl?$link&off=$back"},"<< Back");
}
if ($next==$lim+$off)
{
    $line .= " | " if  $back >= 0 ;
    $line .= $q->a({ -href=>"/cgi-bin/list.pl?$link&off=$next"},"Next >>");
}
print $q->center($line);
print $q->end_html();

sub getWResult
{
    (my $dbh, my $key, my $table, my $where) = @_;

    my $sth=$dbh->prepare("SELECT $key FROM $table WHERE $where ");
    $sth->execute();
    my $result=$sth->fetchrow_array();
    $sth->finish();
    return $result;
}

sub Exit
{
    (my $dbh, my $message) = @_;
    print $q->p("$message");
    $dbh->disconnect();
    print $q->end_html;
    exit;
}

sub convertIP
{
    my $IP=shift;
    $IP=sprintf("%x",$IP);
    if (length($IP) < 8) { $IP = '0' . $IP; }
    return unpack("a2 a2 a2 a2",$IP);
}
