#!/usr/bin/perl

BEGIN { push (@INC,'/var/apache/cgi-bin') ;};

use CGI;
use DBI;          # database module
use dbh;
#use Date::Format; # to convert the time in seconds to a string
use strict;


my $packet_id;
my $q = new CGI;
my $sid;
my $cid;
my $signature=0+$q->param("signature");
my $hostname;
my @cols=();
my $sql;
my $sth;
my $lim=0+$q->param("lim");
my $off=0+$q->param("off");
my $proto=0+$q->param("proto");
$lim=20 if $lim==0;

print $q->header("text/html");
print $q->start_html("Snort DB");

my $dbh = dbh::OpenDB();

if ($signature == 0)
{
    Exit($dbh,"Need a signature.");
}
$sql="SELECT event.sid,event.cid,event.timestamp FROM event WHERE signature=$signature ORDER BY timestamp DESC LIMIT $lim OFFSET $off";
$sth=$dbh->prepare($sql);
$sth->execute();

my $time;
my $count=$off;
my @SRC=();
my @DST=();
my $src_ip;
my $dst_ip;
my $packet='';
print $q->h1({-align=>"center"}, getWResult($dbh,"sig_name", "signature","sig_id=$signature"));

while (($sid,$cid,$time)=$sth->fetchrow_array())
{
    $count++;
    while (length($time) < 26) { $time .= "0"; }
    my $src=getWResult($dbh,"ip_src","iphdr","(cid=$cid AND sid=$sid)");
    my $dst=getWResult($dbh,"ip_dst","iphdr","(cid=$cid AND sid=$sid)");
    @SRC=convertIP($src); 
    @DST=convertIP($dst); 
    $src_ip='';
    $dst_ip='';
    for (my $i=0; $i<4; $i++) 
    { 
	$src_ip .= hex($SRC[$i]); 
	$dst_ip .= hex($DST[$i]); 
	if ($i<3) 
	{ 
	    $src_ip .= ".";
	    $dst_ip .= ".";
	}
    }
    $packet = $sid . "-" . $cid;
    push @cols, $q->td( {-align => "center" },
			[ $count, $q->a({-href=>"/cgi-bin/db-cgi.pl?sid=$sid&cid=$cid"}, $packet), $time, 
$q->a({-href=>"/cgi-bin/ip.pl?src=$src"}, $src_ip), 
$q->a({-href=>"/cgi-bin/ip.pl?dst=$dst"}, $dst_ip), ]);
}
$sth->finish();

print $q->table( { -border=>1, -width=>"100%" },   
		 $q->Tr( [ $q->th( {-bgcolor=>"#cccccc"},  
				   [ "#" , "Packet-ID", "Time", "Source","Destination"  ] ), 
			   @cols,  ] )
		 );

$dbh->disconnect();
my $next=$count;
my $back=$off-$lim;
$back=0 if $back < 0;

my $line='';
if ($back >0 )
{
    $line .= $q->a({ -href=>"/cgi-bin/list.pl?lim=$lim&off=$back"},"<< Back");
    $line .= " | "
}
if ($next == $lim+$off)
{
    $line .= $q->a({ -href=>"/cgi-bin/list.pl?lim=$lim&off=$next"},"Next >>");
}
print $q->center($line);
print $q->end_html();

sub getWResult
{
    (my $dbh, my $key, my $table, my $where) = @_;

    my $sth=$dbh->prepare("SELECT $key FROM $table WHERE $where ");
    $sth->execute();
    my $result=$sth->fetchrow_array();
    $sth->finish();
    return $result;
}

sub Exit
{
    (my $dbh, my $message) = @_;
    print $q->p("$message");
    $dbh->disconnect();
    print $q->end_html;
    exit;
}

sub convertIP
{
    my $IP=shift;
    $IP=sprintf("%x",$IP);
    if (length($IP) < 8) { $IP = '0' . $IP; }
    return unpack("a2 a2 a2 a2",$IP);
}
