#!/usr/bin/perl

BEGIN { push (@INC,'/var/apache/cgi-bin') ;};

use CGI;
use DBI;          # database module
use dbh;
#use Date::Format; # to convert the time in seconds to a string
use strict;


my $packet_id;
my $q = new CGI;
my $sid;
my $cid;
my $hostname;
my @cols;
my $sql;
my $sth;

print $q->header("text/html");
print $q->start_html("Snort DB");

my $dbh=dbh::OpenDB();

my $ipcount=getResult($dbh,"SELECT count(cid) FROM iphdr");
my $tcpcount=getResult($dbh,"SELECT count(cid) FROM tcphdr");
my $udpcount=getResult($dbh,"SELECT count(cid) FROM udphdr");
my $icmpcount=getResult($dbh,"SELECT count(cid) FROM icmphdr");

print $q->h1("Alerts in database");
print $q->table( { -border=>1, -width=>"100%" },
		 $q->Tr( [ $q->th( {-bgcolor=>"#cccccc"},
			   [ "IP-Packets", "TCP", "UDP", "ICMP", "other"  ] ), 
			   $q->td( {-align => "center" }, 
				[ 
$q->a({-href=>"/cgi-bin/list.pl?off=0&lim=20"}, $ipcount), 
$q->a({-href=>"/cgi-bin/list.pl?off=0&lim=20&proto=6"}, $tcpcount),
$q->a({-href=>"/cgi-bin/list.pl?off=0&lim=20&proto=17"}, $udpcount), 
$q->a({-href=>"/cgi-bin/list.pl?off=0&lim=20&proto=1"},$icmpcount),
$q->a({-href=>"/cgi-bin/list.pl?off=0&lim=20&proto=-1"},
       $ipcount-$tcpcount-$udpcount-$icmpcount) ] )
			   ] ) 
		 );

$sql="SELECT sid,hostname FROM sensor";
my $sth2=$dbh->prepare($sql);
$sth2->execute();

while (($sid,$hostname)=$sth2->fetchrow_array())
{
    $ipcount=getResult($dbh,"SELECT count(cid) FROM iphdr WHERE sid=$sid");
    $tcpcount=getResult($dbh,"SELECT count(cid) FROM tcphdr WHERE sid=$sid");
    $udpcount=getResult($dbh,"SELECT count(cid) FROM udphdr WHERE sid=$sid");
    $icmpcount=getResult($dbh,"SELECT count(cid) FROM icmphdr WHERE sid=$sid");

    push @cols, $q->td( {-align => "center" },
			[ 
$q->a({-href=>"/cgi-bin/list.pl?off=0&lim=20&sid=$sid"}, $sid), 
$q->a({-href=>"/cgi-bin/list.pl?off=0&lim=20&sid=$sid"}, $hostname), 
$q->a({-href=>"/cgi-bin/list.pl?off=0&lim=20&sid=$sid"}, $ipcount), 
$q->a({-href=>"/cgi-bin/list.pl?off=0&lim=20&sid=$sid&proto=6"}, $tcpcount), 
$q->a({-href=>"/cgi-bin/list.pl?off=0&lim=20&sid=$sid&proto=17"}, $udpcount), 
$q->a({-href=>"/cgi-bin/list.pl?off=0&lim=20&sid=$sid&proto=1"}, $icmpcount), 
$q->a({-href=>"/cgi-bin/list.pl?off=0&lim=20&sid=$sid&proto=-1"},  
			  $ipcount-$tcpcount-$udpcount-$icmpcount) ]);
}
$sth2->finish();

print $q->hr;
print $q->h1("Alerts per sensor");
print $q->table( { -border=>1, -width=>"100%" },   
		 $q->Tr( [ $q->th( {-bgcolor=>"#cccccc"},  
				   [ "SID" , "Sensor", "IP-Packets", "TCP", 
				     "UDP", "ICMP", "other"  ] ), 
			   @cols,  ] )
		 );

my $distinct = getUCount($dbh,"signature","event");
my $src_ip = getUCount($dbh,"ip_src","iphdr");
my $dst_ip = getUCount($dbh,"ip_dst","iphdr");

print $q->hr;
print $q->p("<p>Different alerts: $distinct<BR>",
"Different sources: $src_ip<BR>","Different dests: $dst_ip");
print $q->hr;
$dbh->disconnect();
print $q->end_html();


sub getUCount
{
    (my $dbh, my $key, my $table) = @_;
    my $sql="SELECT DISTINCT ON ($key) $key from $table";
    my $sth=$dbh->prepare($sql);
    $sth->execute();
    my $result=$sth->rows;
    $sth->finish();
    return $result;
}

sub getResult
{
    (my $dbh, my $sql) = @_;

    my $sth=$dbh->prepare($sql);
    $sth->execute();
    my $result=$sth->fetchrow_array();
    $sth->finish();
    return $result;
}

sub Exit
{
    (my $dbh, my $message) = @_;
    print $q->p("$message");
    $dbh->disconnect();
    print $q->end_html;
    exit;
}
