#ifndef ALERTMSG_LENGTH
#include "decode.h"
#endif

#ifdef GENUA
#error GENUA not implemented here!
#endif

/* A simple hack to decompose IP4 addresses in dotted parts */
typedef union _IP 
{ 
  struct {u_int8_t b1, b2, b3, b4; } IPb;
  u_int32_t IPc;
} IP;

typedef union _TCPIcmp
{
  struct { u_int8_t ICMPType, ICMPCode; } ICMP;
  struct  { u_int8_t x2, flags; } TCP;
} TCPIcmp;

typedef struct _AlertData
{
  u_int8_t alertmsg[ALERTMSG_LENGTH]; /* variable.. */
  u_int32_t sig_id;
  u_int32_t generator;
  u_int32_t sid;
  u_int32_t cid;
  u_int32_t reference;
  u_int32_t sensorIP;
  u_int32_t srcip;
  u_int32_t dstip;
  u_int16_t sport;
  u_int16_t dport;
  u_int32_t priority;
  u_int32_t classification;
  u_int8_t protocol;
  TCPIcmp Flag; 
  time_t time;
} AlertData;

typedef struct _Mail
{
  char *line;             /* pointer to the mail line */
  struct _Mail *next; /* pointer to the next line struct */
} Mail;

typedef struct _Sensor
{
    u_int32_t IP;
    char * Name;
    struct _Sensor * next;
} Sensor;
