#include "FLoPconfig.h"
#undef PACKAGE
#undef VERSION
#undef PACKAGE_BUGREPORT
#undef PACKAGE_NAME
#undef PACKAGE_STRING
#undef PACKAGE_TARNAME
#undef PACKAGE_VERSION

#ifndef HAVE_U_INT8_T
#define u_int8_t  uint8_t
#endif
#ifndef HAVE_U_INT16_T
#define u_int16_t uint16_t
#endif
#ifndef HAVE_U_INT32_T
#define u_int32_t uint32_t
#endif

#include <time.h>
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include "event.h"
#include "generators.h"
#include "decode.h"
#include "rules.h"
#include "plugbase.h"
#include "parser.h"
#include "debug.h"
#include "util.h"
#include "spo_alert_unixsock_db.h"

#include "snort.h"

#ifdef MYSQL_DB
#include <mysql/mysql.h>
#endif

#ifdef POSTGRES
#include <libpq-fe.h>
#endif

#define DB_MYSQL 1
#define DB_POSTGRES 2

#ifndef HAVE_U_INT8_T 
#define u_int8_t  uint8_t
#endif
#ifndef HAVE_U_INT16_T 
#define u_int16_t uint16_t
#endif
#ifndef HAVE_U_INT32_T
#define u_int32_t uint32_t
#endif



typedef struct _DatabaseData
{
  char *dbname;
  u_int32_t sid;
  u_int32_t cid;
  int reference;
  
  char * password;
  char * user;
  char * sensor_name;
  char * socket_name;
  int  encoding;
  int FullPayload;
  int Reference;
  int tz;
  int DBschema_version;
  int DBtrust;
  int transaction;
  int DBtype;
#if defined ALERT || defined DROP
  u_int32_t sensorIP;
#endif
#ifdef MYSQL_DB
    MYSQL * m_sock;
    MYSQL_RES * m_result;
    MYSQL_ROW m_row;
#endif
#ifdef POSTGRES
   PGconn     *p_sock;
   PGresult   *p_result;
#endif
} DatabaseData;

/* constants */
#define MAX_QUERY_LENGTH 8192
#define MAX_INSERT_LENGTH 262144
#define LATEST_DB_SCHEMA_VERSION 105

#define MAXBUFFSIZE 65536 /* at least one complete TCP session */

/* prototypes */
int DatabaseInit(DatabaseData *);
int Database(AlertpktDB *, char *, void *, Event *, void *Packet_ptr);
char * snort_escape_string(char *, DatabaseData *);
void SpoDatabaseCleanExitFunction(int, void *);
int CheckDBVersion(DatabaseData *);
int Insert(char *, DatabaseData *);
int Select(char *, DatabaseData *);
int Connect(DatabaseData *);
void Disconnect(DatabaseData *);
/* Functions taken form snort/plugbase.c */
int GetLocalTimeZone();
char *GetTimeStamp(struct timeval * ts, int tz);
char *GetCurrentTimeStamp();
char *Base64(u_char * xdata, int length);
char *Ascii(u_char *xdata, int length);
char *Fasthex(u_char *xdata, int length);
void Printf(char *format,...);

