#include "Signal.h"
#include <signal.h>

/* signal handler with automatic restart of system calls */

sighandler_t Signal(int signr, sighandler_t sighandler)
{
   struct sigaction   new_hd, old_hd;

   new_hd.sa_handler = sighandler;
   sigemptyset(&new_hd.sa_mask);
   new_hd.sa_flags = 0;

#ifdef SA_RESTART
      new_hd.sa_flags |= SA_RESTART;  /* necessary for continuing SIGALERTS */
#endif

   if (sigaction(signr, &new_hd, &old_hd) < 0)
      return((sighandler_t) SIG_ERR);

   return(old_hd.sa_handler);
}

