#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>


#define MAXFD 64

int 
getdaemon(char *dir, mode_t mask)
{
  pid_t pid;
  int i;

  if (( pid = fork() ) <0 ) 
     return (-1);     /* fork failed */
  else if (pid != 0) 
     exit(0);        /* parent exits */  	

  /* only child process here */

  setsid(); /* become session leader */

  /* change working directory */
  if (dir==NULL) 
    i=chdir("/"); 
  else 
    i=chdir(dir);

  if (i) return (-1); /* chdir failed */

  umask(mask);   
 
  for (i=0; i< MAXFD; i++) 
    close(i);    /* close all possibly opened filedescriptor */

  return(0);  /* success */
}
